<template>
  <single-panel>
    <div class="agent-card" v-if="agent">
      <header class="agent-card__header">
        <h1  @click="$router.go(-1)">
          <i class="icon chevron-left"></i>
          {{ agent.title }}
          <sup>
            {{ $options.rolesMap[generalInfo.roleCode ]}}
            <!-- <span :class="['status', agent.status === 'онлайн' ? 'is-online' : '']">{{ agent.status }}</span> -->
          </sup>
        </h1>
      </header>

      <nav class="agent-card__nav">
        <ob-tabs
            v-model="activeTab"
            :items="tabsItems"
            :no-border="true"
        />
      </nav>

      <div class="agent-card__content">
        <transition name="fadeIn" mode="out-in">
          <keep-alive>
            <component
                :style="{ transitionDuration: '0.1s' }"
                :is="activeComponent"
                :uuid="$route.params.id"
                :agent="agent"
                :groups="generalInfo.participantStats.groups"
                :transportType="activeTab.uuid"
            />
          </keep-alive>
        </transition>
      </div>
    </div>
    <div class="agent-card" v-else>
      <header class="agent-card__header">
        <i class="icon chevron-left"></i>
        <h1  @click="$router.go(-1)">
          Назад
        </h1>
      </header>
      <div class="agent-card__content agent-card__content--empty">
        Нет информации
      </div>
    </div>
  </single-panel>
</template>

<script>
import {mapGetters, mapState, mapActions} from 'vuex';
import api from '@/api';
import singlePanel from 'common-components/src/obComponents/obSinglePanels';
import ObTabs from 'common-components/src/obComponents/obTabs';
import agentCardComponent from './components/agentCardComponent';
import agentOrdersComponent from './components/agentOrdersComponent';
import agentResourcesComponent from './components/agentResourcesComponent';
import agentDriversComponent from './components/agentDriversComponent';
import agentSublistsComponent from '../Subscriptions/index';

export default {
  name: 'agentCard',

  resourcesMap: {
    TRAILER: 'Прицепы',
    SEMITRAILER: 'Полуприцепы',
    VAN: 'Фургоны',
    CONTAINER_TRUCK: 'Контейнеровозы',
    TRACTOR: 'Тягачи',
    TRAWL: 'Тралы'
  },

  rolesMap: {
    CLICAR: 'Экспедитор',
    CARRIER: 'Перевозчик',
    CLIENT: 'Клиент'
  },

  tabsMap: {
    'карточка': 'Карточка участника',
    'заказы': 'Заказы',
    tractors: 'Тягачи',
    drivers: 'Водители',
    semitrailers: 'Полуприцепы',
    trailers: 'Прицепы',
    container_trucks: 'Контейнеровозы',
    vans: 'Фургоны',
    sublists: 'Подписки',
  },

  components: {
    singlePanel,
    ObTabs,
    agentCardComponent,
    agentOrdersComponent,
    agentResourcesComponent,
    agentDriversComponent,
    agentSublistsComponent
  },

  data () {
    return {
      agent: null,
      activeTab: { uuid: this.$route.query.tab || 'карточка', title: this.$options.tabsMap[this.$route.query.tab] || 'Карточка участника' }
    }
  },
  async created () {
    const res = await api.linkBrowser.getAllAgentInfo(this.$route.params.id);
    if (res.domains.length) {
      if (!this.generalInfo.roleCode) {
        const info = await api.linkBrowser.getAgent(res.domains[0].participantUuid);
        this.setGeneralInfo(info)
      }
      this.agent = {
        uuid: res.domains[0].participantUuid,
        title: res.domains[0].participantTitle,
        status: 'онлайн',
        groups: res.domains[0].groups,
        role: this.generalInfo.roleCode
      };

      const director = this.agent.groups.find(group => group.requisiteGroupTitle === "Генеральный директор");
      director.fields.splice(director.fields.findIndex(i =>{
        return i.fieldCode === "ceo_criminal";
      }), 1);
    }
  },
  watch: {
    activeTab (value) {
      this.$router.replace({ query: { ...this.$route.query, tab: value.uuid } })
    }
  },
  computed: {
    ...mapGetters({
      role: 'user/role',
      isModerator: 'user/isModerator'
    }),
    ...mapState('logdomains', ['generalInfo']),
    activeComponent() {
      let componentsMap = {
        'карточка': agentCardComponent,
        'заказы': agentOrdersComponent,
        'tractors': agentResourcesComponent,
        'semitrailers': agentResourcesComponent,
        'trailers': agentResourcesComponent,
        'container_trucks': agentResourcesComponent,
        'vans': agentResourcesComponent,
        'sublists': agentSublistsComponent,
        drivers: agentDriversComponent
      };
      return componentsMap[this.activeTab.uuid]
    },
    agentIsCarrier () {
      return this.agent?.role === 'CARRIER'
    },
    tabsItems () {
      return [
        {
          uuid: 'карточка',
          title: 'Карточка участника'
        },
        {
          uuid: 'заказы',
          title: `Заказы`,
          isDisabled: true
        },
        {
          uuid: 'tractors',
          title: 'Тягачи',
        },
        {
          uuid: 'drivers',
          title: 'Водители'
        },
        {
          uuid: 'semitrailers',
          title: 'Полуприцепы',
        },
        {
          uuid: 'trailers',
          title: 'Прицепы',
        },
        {
          uuid: 'container_trucks',
          title: 'Контейнеровозы',
        },
        {
          uuid: 'vans',
          title: 'Фургоны',
        },
        {
          uuid: 'sublists',
          title: 'Подписки',
          class: 'test',
          isHidden: !this.isModerator || !this.agentIsCarrier
        }
      ]
    }
  },
  methods: {
    ...mapActions({
      setGeneralInfo: 'logdomains/setGeneralInfo'
    }),
  }

}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.agent-card__header {
  display: flex;
  align-items: center;
  padding: 20px 25px;
  position: relative;
  z-index: 2;
  background-color: #fff;
  border-bottom: 1px solid $lavender;
}

h1 {
  @include font-mixin(20px, 28px, 700, $style-black);
  cursor: pointer;

  i {
    font-size: 16px;
    color: $color-blue-navy-blue;
    position: relative;
    top: -2px;
    margin-right: 10px;
  }

  sup {
    @include font-mixin(11px, 12px, 400, $gray-slate, 0.6, uppercase);
    opacity: 0.8;
  }

  .is-online {
    color: $deep-blue;
  }
}

.agent-card__nav {
  position: relative;
  z-index: 1;
  padding-left: 25px;
  padding-right: 25px;
  @include font-mixin(16px, 20px, 400, $gray-slate, 0.4px);
  box-shadow: 0 2px 8px rgba(0, 75, 200, 0.14);
}

.agent-card__content {
  padding: 40px 25px;

  &[transporttype='sublists']{
    box-shadow: none;
    margin: 0;
    width: 100%;
  }
  &--empty {
    display: flex;
    justify-content: center;
    align-items: center;
    font-size: 16px;
    line-height: 20px;
    text-align: center;
    letter-spacing: 0.4px;
    color: $color-text-base;
  }
}
</style>
